﻿using DataSharing.DataExchange;
using DataSharing.Province;
using DataSharing.SendTask;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DataSharing.ZiGong
{
    /// <summary>
    /// 执行推送任务
    /// </summary>
    public class ZiGongSendTaskDataService : ISendTaskDataService
    {

        private readonly ILogger<ZiGongSendTaskDataService> _logger;
        private readonly IPusherProviderService _pusherProviderService;
        private readonly IDataExchangePusherProviderService _dataExchangePusherProviderService;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="logger"></param>
        /// <param name="pusherProviderService"></param>
        /// <param name="enterprisePusherProviderService"></param>
        /// <param name="dataExchangePusherProviderService"></param>
        /// <param name="zzptPusherProviderService"></param>
        public ZiGongSendTaskDataService(ILogger<ZiGongSendTaskDataService> logger,
         IPusherProviderService pusherProviderService,
         IDataExchangePusherProviderService dataExchangePusherProviderService)
        {
            _logger = logger;
            _pusherProviderService = pusherProviderService;
            _dataExchangePusherProviderService = dataExchangePusherProviderService;
        }

        /// <summary>
        /// 执行推送任务
        /// </summary>
        /// <param name="dto"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        public async Task SendTask(DsSendTask dto, CancellationToken cancellationToken)
        {
            if (dto is null)
                return;
            _logger.LogWarning("这里是自贡的服务--------------------------------------");

            switch (dto.PlatformSource)
            {
                case Share.Enums.EPlatformSource.Province:
                    await _pusherProviderService.SendProvinceDataPusher(dto, cancellationToken);
                    break;
                case Share.Enums.EPlatformSource.Police110:
                    break;
                case Share.Enums.EPlatformSource.CityDataExchange:
                    await _dataExchangePusherProviderService.SendDataExchangeDataPusher(dto, cancellationToken);
                    break;
                default:
                    break;
            }
        }
    }
}
